const { Machine, actions } = require('../../lib/index');
const { interpret } = require('../../lib/interpreter');
const { send, sendParent } = actions;

const pingMachine = Machine({
  id: 'ping',
  initial: 'active',
  states: {
    active: {
      onEntry: sendParent('PING', { delay: 1 }),
      on: {
        PONG: {
          actions: sendParent('PING', {
            delay: 1000
          })
        }
      }
    }
  }
});

const pongMachine = Machine({
  id: 'pong',
  initial: 'active',
  states: {
    active: {
      on: {
        PING: {
          actions: [
            sendParent('PONG', {
              delay: 1000
            })
          ]
        }
      }
    }
  }
});

const parentMachine = Machine({
  id: 'parent',
  initial: 'active',
  states: {
    active: {
      invoke: [
        { src: pingMachine, forward: true },
        { src: pongMachine, forward: true }
      ]
    }
  }
});

const interpreter = interpret(parentMachine)
  .onEvent(s => console.log(s))
  .start();
