import React from "react";
import { Interpreter } from "xstate/lib/interpreter";
import { StateNode, State } from "xstate";
interface StateChartProps {
    machine: StateNode<any> | string;
    height?: number | string;
}
interface StateChartState {
    machine: StateNode<any>;
    current: State<any, any>;
    preview?: State<any, any>;
    previewEvent?: string;
    view: string;
    code: string;
    toggledStates: Record<string, boolean>;
    service: Interpreter<any>;
    error?: any;
}
export declare class StateChart extends React.Component<StateChartProps, StateChartState> {
    state: StateChartState;
    svgRef: React.RefObject<SVGSVGElement>;
    componentDidMount(): void;
    renderView(): JSX.Element | null;
    updateMachine(code: string): void;
    render(): JSX.Element;
}
export {};
